require 'thor'

module FlatironVideoUploader
  class Cli < Thor
    desc "upload FILE", "Upload FILE to youtube and s3 for offline use. Specify --batch if this is a lecture video"
    long_desc <<-LONGDESC

    Uploads to youtube and gives you the embed link. If this is a topic video 
    (not a lecture video) it will upload the full resolution to s3 as well as 
    transcode the video to an iPad specific format to upload to s3.

    If you specify the --batch option then this is a LECTURE VIDEO. That means 
    that we won't upload the full resolution video. Also the batch will become
    one of the tags for the video
    LONGDESC
    method_option :batch, :type => :string, :default => "", :desc => "Specify which batch this lecture video is for."
    def upload (file)
      FlatironVideoUploader::Runner.upload_video(file,options[:batch])
    end
  end
end
